### M2UHF-RFID Android™\* API Documentation
### Documentation on how to use the service  
### Version: 1.18
\* Registered Trademark – Android™ – Android is a trademark of Google LLC

![](images/icon.png)


**Content**

1. Overview  
  1.1. About this Documentation  
  1.2. Applicable documents  
  1.3. Structure of the API  
2. IRI API of Impinj  
3. M2UHF-RFID Android API  
  3.1. Module functions  
  3.2. Module interface  
  3.3. Reader functions  
  3.4. Reader interfaces  
  3.5. Reader and API settings  
    3.5.1. Get settings  
    3.5.2. Set settings  
  3.6. Enums  
    3.6.1. Ipj error enum  
    3.6.2. Ipj key enum  
    3.6.3. Other enums  
  3.7. Code example  
4. Using the M2UHF-RFID API  
  4.1. Preparation  
  4.2. Add the API to the app  
  4.3. Add JavaDoc to the app  
  4.4. Troubleshooting  
5. Version history  

## Overview

### About this Documentation

This document is intended for developers programming an Android app with the use of the M2UHF-RFID API to control the M2UHF-RFID Shortrange module or the M2UHF-RFID Midrange module. In this documentation only M2UHF-RFID API relevant information is noted. For more information, please use the IRI API documentation which is more detailed. It is available online: [https://platform.impinj.com/indy/itk/latest/index.html](https://platform.impinj.com/indy/itk/latest/index.html)

This documentation is valid as of API version 1.18. The API contains additional descriptions that make use of JavaDoc.

### Applicable documents

With this document the following documents are provided:

- Two code samples files showing the usage of the M2UHF-RFID API in Java
- JavaDoc Zip file of the M2UHF-RFID API

### Structure of the API

After the M2UHF-RFID Shortrange module or the M2UHF-RFID Midrange module has been connected to the M2Smart®SE, the ACD ModuleService detects the module and sends a message to the API. The API then can send the powerOn command to the ACD MCon (via ACD ModuleService). The ACD MCon then powers on the Impinj RS reader. After the reader is powered, it will establish a USB connection to the M2Smart®SE and a virtual interface is generated by a USB driver. It can be initialized with the IRI API.

The IRI API can be controlled by an Android app using the M2UHF Android API.
 The diagram below shows the interaction of all components:

![](images/UHF_API.png)

## IRI API of Impinj

The M2UHF-RFID API is a wrapper around the Impinj IRI API (written in C) to make functions of the IRI API available in Java or Kotlin. Most functions, parameters, structures, etc. in the ACD M2UHF-RFID API have the same design as in the IRI API. The Version 1.8.12.240 of the IRI API is used.

## M2UHF-RFID Android API

The API is organized into two parts:

- **Module functions:** Controls the module power status (via ACD ModuleService) and handles module events
- **Reader functions:** Controls the RFID reader (USB connection) and handles reader events using the IRI API

The M2UHF-RFID API configures the reader with default settings while it is initialized. All settings can be adjusted after the reader is initialized. The reader should not be accessed directly from the UI thread as some calls take more time to complete.

### Module functions

The following functions are available in the Module class:

**Class name: de.acdgruppe.m2uhf\_library.Module**
| **Name** | **Description** |
| --- | --- |
| **Constructor** | Sets a new ModuleStatusReporter instance, provides a plugin for the ACD ModuleService, creates a connection to ACD ModuleService and checks if the module is plugged. This requires some time and must not be started from the UI Thread. Also make sure the App calling this function has [WRITE\_EXTERNAL\_STORAGE](https://developer.android.com/reference/android/Manifest.permission#WRITE_EXTERNAL_STORAGE) and [READ\_EXTERNAL\_STORAGE](https://developer.android.com/reference/android/Manifest.permission#READ_EXTERNAL_STORAGE) permissions before calling this function. After the check is finished, a ModuleStatusReporter callback is triggered. As soon as the ModuleStatusReporter instance is set, events are sent to it whenever the module is (un-) plugged or powered (off).<br/><br/>**Parameters:**<br/>- [Android Context](https://developer.android.com/reference/android/content/Context) – The Context from an activity<br/>- ModuleStatusReporter instance<br/><br/>**Return:** Moduleinstance |
| **powerOn** | Powers on the module. After the module is powered on, a ModuleStatusReporter callback is triggered. Powering on the module needs some time. It is recommended to wait 1000 ms before initializing the reader. When the device enters the suspend mode, the module is powered off automatically. When the device leaves the suspend mode, the module will be powered on again.<br/><br/>**Parameters:** - <br/><br/>**Return:** - |
| **powerOff** | Powers off the module. Call Main.deInit before powering off the reader. If the reader is not deinitialized when powering it off, the Android driver might not clean up the interface correctly. This may cause issues if the device is operated for a longer period with many on-off operations. After the module is powered off, a ModuleStatusReporter callback is triggered.<br/><br/>**Parameters:** - <br/><br/>**Return:** - |

**Class name: de.acdgruppe.m2uhf\_library.Module**
| **Name** | **Description** |
| --- | --- |
| **checkPower-Status** | Checks if the module is powered. The result of this check triggers a ModuleStatusReporter event.<br/><br/>**Parameters:** - <br/><br/>**Return:** - |
| **deInit** | Disconnects the ACD ModuleService. Should be called before the App is finished.<br/><br/>**Parameters:** - <br/><br/>**Return:** - |
| **isPlugged** | Checks if the module is plugged.<br/><br/>**Parameters:** - <br/><br/>**Return:** Boolean – true, if the module is plugged |
| **isPowered** | Checks if the module is powered. This reads an internal variable of the API which is refreshed on every module relevant command the API gets. Use checkPowerStatus to get the current power status of the module.<br/><br/>**Parameters:** - <br/><br/>**Return:** Boolean – true, if the module is powered |
| **getStatus** | Gets the current module status. This function combines isPlugged and isPowered functions.<br/><br/>**Parameters:** - <br/><br/>**Return:** Ipj\_Error.SUCCESS if the module is plugged and powered |
| **getMcon-Version** | Returns the MCon version string.<br/><br/>**Parameters:** - <br/><br/>**Return:** String – MCon version |

### Module interface

The module interface provides callback events which will be triggered by the API:

**Interface name: de.acdgruppe.m2uhf\_library.ModuleStatusReporter**
| **Name** | **Description** |
| --- | --- |
| **onModule-Plugged** | This callback is triggered whenever the module is plugged on or off.<br/><br/>**Parameters:** - <br/><br/>**Return:** Module instance |
| **onModule-Powered** | This callback is triggered whenever the module is powered on or off. It will also be triggered when the module is plugged off. Powering on the module needs some time. It is recommended to wait 1000 ms before initializing the reader.<br/><br/>**Parameters:** - <br/><br/>**Return:** - |
| **onModule-Error** | This callback is triggered when the [WRITE\_EXTERNAL\_STORAGE](https://developer.android.com/reference/android/Manifest.permission#WRITE_EXTERNAL_STORAGE) and [READ\_EXTERNAL\_STORAGE](https://developer.android.com/reference/android/Manifest.permission#READ_EXTERNAL_STORAGE) permissions are not granted or an error occurred with the ModuleService connection.<br/><br/>**Parameters:** - <br/><br/>**Return:** Ipj\_Error |

### Reader functions

Before any of these functions can be used, the module has to be plugged and powered. If any function with Ipj\_Error as return value was performed successfully, Ipj\_Error.SUCCESSis returned. If there was an error, the corresponding error code is returned.

The Main class provides the following functions:

**Class name: de.acdgruppe.m2uhf\_library.Main**
| **Name** | **Description** |
| --- | --- |
| **init** | Initializes the RFID reader and sets default settings. Must be done before any other actions. Initialization requires some time and must not be started from the UI Thread.<br/><br/>**Parameters:** - <br/><br/>**Return:** Ipj\_Error |
| **deInit** | Deinitializes the RFID reader. Should be called before the reader is powered off.<br/><br/>**Parameters:** - <br/><br/>**Return:** Ipj\_Error |
| **startReader** | Starts the tag inventory process. After 120 seconds the reader is auto stopped to prevent overheating. All tags within range are reported with JNIReporter.onTagUpdate.<br/><br/>**Parameters:** - <br/><br/>**Return:** Ipj\_Error |
| **stopReader** | Stops the tag inventory process.<br/><br/>**Parameters:** - <br/><br/>**Return:** Ipj\_Error |
| **writeTag** | Writes new data on the specified tag memory. After the data is written, a short inventory is executed which triggers the JNIAdvancedReporter.onTagOperationReport callback with the result. The selected tag will be reported in a IpjTagOperationReport where the TagOperationType is TagOperationType.WRITE or TagOperationType.WRITE\_EPC. Arrays must not be empty.<br/><br/>**Parameters:**<br/>- Int [] – selected tag ID, each array element contains 1 word (as HEX value). The maximum size is 32 (32 words = 64 bytes)<br/>- Boolean – true, if selected tag ID is TID, false if selected tag ID is EPC<br/>- Int [] – data array to write to the selected ID, each array element contains 1 word (as HEX value)<br/>- Enums.MemBank – the memory bank to be written to<br/>- Int – index of the memory bank where the data should be written to<br/>- Long – long value of the password (2 words), can be 0 if no password is needed<br/><br/>**Return:** Ipj\_Error.SUCCESS if the write process was successful. Due to the design of the write functionality, this function returns true even when the tag was moved out of the field. If JNIAdvancedReporter.onTagOperationReportwas called, check if there is an error in the report. If JNIAdvancedReporter.onTagOperationReportis not called, the tag was moved out of the field. |

**Class name: de.acdgruppe.m2uhf\_library.Main**
| **Name** | **Description** |
| --- | --- |
| **readTag** | Reads data from the specified tag memory. The specified data is reported with JNIAdvancedReporter.onTagOperationReport where the TagOperationType is TagOperationType.READ. Arrays must not be empty.<br/><br/>**Parameters:**<br/>- Int [] – selected tag ID, each array element contains 1 word (as HEX value). The maximum size is 32 (32 words = 64 bytes)<br/>- Boolean – true, if selected tag ID is TID, false if selected tag ID is EPC<br/>- Enums.MemBank – the memory bank to be read from<br/>- Int – index of the memory bank where the data should be read from<br/>- Int – number of words to read. The maximum count is 32<br/>- Long – long value of the password (2 words), can be 0 if no password is needed<br/><br/>**Return** : Ipj\_Error.SUCCESS if the read process was successful. Also check if JNIAdvancedReporter.onTagOperationReport was called and if the report contains an error. |
| **setLock-OnTag** | Sets a Enums.LockMode to the whole tag. Does not work with all tags, most tags only support Enums.PERMA\_LOCKED. After the action is completed, a short inventory is executed which triggers the JNIAdvancedReporter.onTagOperationReport callback. The selected tag will be reported in a IpjTagOperationReport where the TagOperationType is TagOperationType.Lock or TagOperationType.BLOCKPERMALOCK. Arrays must not be empty.<br/><br/>**Parameters:**<br/>- Int [] – selected tag ID, each array element contains 1 word (as HEX value). The maximum size is 32 (32 words = 64 bytes)<br/>- Boolean – true, if selected tag ID is TID, false if selected tag ID is EPC<br/>- Enums.LockMode – the lock mode to use<br/>- Long – long value of the password (2 words), can be 0 if no password is needed<br/><br/>**Return**: Ipj\_Error.SUCCESS if the lock process was successful. Also check if JNIAdvancedReporter.onTagOperationReport was called and if the report contains an error. |
| **setLock-OnMemBank** | Sets a Enums.LockMode 0 to the specified memory bank of the tag. After the action is completed, a short inventory is executed which triggers the JNIAdvancedReporter.onTagOperationReport callback. The selected tag will be reported in a IpjTagOperationReport where theTagOperationType is TagOperationType.Lock or TagOperationType.BLOCKPERMALOCK. Arrays must not be empty.<br/><br/>**Parameters:**<br/>- Int [] – selected tag ID, each array element contains 1 word (as HEX value). The maximum size is 32 (32 words = 64 bytes)<br/>- Boolean – true, if selected tag ID is TID, false if selected tag ID is EPC<br/>- Enums.MemBank – the memory bank on which the lock mode is set<br/>- Enums.LockMode – the lock mode to use<br/>- Long – long value of the password (2 words), can be 0 if no password is needed<br/><br/>**Return**: Ipj\_Error.SUCCESS if the lock process was successful. Also check if JNIAdvancedReporter.onTagOperationReport was called and if the report contains an error. |

**Class name: de.acdgruppe.m2uhf\_library.Main**
| **Name** | **Description** |
| --- | --- |
| **killTag** | Kills the selected tag. After the action is completed, a short inventory is executed which triggers the JNIAdvancedReporter.onTagOperationReport callback. The selected tag will be reported in a IpjTagOperationReport where the TagOperationType is TagOperationType.KILL. Arrays must not be empty.<br/><br/>**Parameters:**<br/>- Int [] – selected tag ID, each array element contains 1 word (as HEX value). The maximum size is 32 (32 words = 64 bytes)<br/>- Boolean – true, if selected tag ID is TID, false if selected tag ID is EPC<br/>- Long – long value of the password (2 words), must not be 0<br/><br/>**Return:** Ipj\_Error.SUCCESS if the lock process was successful. Also check if JNIAdvancedReporter.onTagOperationReport was called and if the report contains an error. |
| **setCallback** | Sets a JNIReporterinstance to the API. The API will use this instance to transfer data and events from the reader to the app.<br/><br/>**Parameters:**<br/>- JNIReporterinstance<br/><br/>**Return:** - |
| **setAdvanced-Callback** | Sets a JNIAdvancedReporterinstance to the API. The API will use this instance to transfer data and events from the reader to the app.<br/><br/>**Parameters:**<br/>- JNIAdvancedReporterinstance<br/><br/>**Return:** - |
| **isInitialized** | Checks if the module is plugged and powered. Also, the connection to the RFID reader is tested. A command is sent to the reader which needs some time. Do not call this function too often as it will block other reader communications.<br/><br/>**Parameters:** - <br/><br/>**Return:** Boolean – true, if the reader is initialized |
| **get** | Returns a Get instance which can be used to get parameters, settings and information from the reader and the API. More information in chapter 3.5.1. Get settings<br/><br/>**Parameters:** - <br/><br/>**Return:** Get instance |
| **set** | Returns a Set instance which can be used to set parameters to the reader and the API. More information in chapter 3.5.2. Set settings<br/><br/>**Parameters:** - <br/><br/>**Return:** Set instance |

### Reader interfaces

The JNIReporter interface provides callback events which will be triggered by the API while the reader is running:

**Interface name: de.acdgruppe.m2uhf\_library.JNIReporter**

| **Name** | **Description** |
| --- | --- |
| **onStatus-Message** | This callback is triggered whenever an error occurs while the reader is executing an action. This function should not be blocked because otherwise the reader will also be blocked.<br/><br/>**Parameters:**<br/>- Ipj\_Error<br/><br/>**Return:** - |
| **onTag-Update** | This callback is triggered whenever the reader reports a tag while scanning the field (tag inventory). This function should not be blocked because otherwise the reader will also be blocked.<br/><br/>**Parameters:**<br/>- String – EPC of the tag<br/>- String – TID of the tag (only when the tag has a Impinj Monza chip)<br/>- Int – RSSI value of the tag<br/>- Int – phase of the tag<br/>- Int – pc of the tag<br/><br/>**Return:** - |
| **onTag-Status** | **Still in development**<br/>This callback is triggered whenever the reader reports a status report while scanning the field. This can be enabled by setting the appropriate REPORT\_CONTROL\_STATUS key value. It reports the reverse power of tags in the field. This function should not be blocked because otherwise the reader will also be blocked.<br/><br/>**Parameters:**<br/>- Int – tag reverse power<br/><br/>**Return: -** |
| **onAutostop** | This callback is triggered when the reader was stopped after it had scanned for 120 seconds (to prevent overheating).<br/><br/>**Parameters:** - <br/><br/>**Return:** - |

The JNIAdvancedReporter interface provides callback events which will be triggered by the API on actions like write, read, lock or kill:

**Interface name: de.acdgruppe.m2uhf\_library.JNIAdvancedReporter**
| **Name** | **Description** |
| --- | --- |
| **onTag-Operation-Report** | This callback is triggered whenever the reader has finished an action like read, write, lock or kill. The IpjTagOperationReport will include information and data of the previously executed action.<br/><br/>**Parameters:**<br/>- Enums.IpjTagOperationReport – of the previously executed action<br/><br/>**Return: -** |

### Reader and API settings

All settings and parameter of the reader and the API can be set and get with the Get and Set classes. These classes have a private constructor and an instance can only be obtained from a Main instance with the get or set functions.

To learn more about the individual setting keys and values please refer to chapter 3.6.2. Ipj key enum.

#### Get settings

The Get class provides the following functions:

**Class name: de.acdgruppe.m2uhf\_library.Get**
| **Name** | **Description** | 
| --- | --- |
| **DeviceType** | Returns the device type of the current module. RS500 is the SR module (Shortrange), RS1000 is the MR module (Midrange)<br/><br/>**Parameters:** - <br/><br/>**Return:** Enums.DeviceType |
| **DeviceCert** | Returns the device certification (FCC or ETSI).<br/><br/>**Parameters:** - <br/><br/>**Return:** Enums.DeviceCertification |
| **Version** | Returns the version name of the API.<br/><br/>**Parameters:** - <br/><br/>**Return:** String |
| **TxPower** | Returns the value of the ANTENNA\_TX\_POWER key in dBm.<br/><br/>**Parameters:** - <br/><br/>**Return:** Float |
| **RFMode** | Returns the value of the RF\_MODE key.<br/><br/>**Parameters:** - <br/><br/>**Return:** Int |
| **Session** | Returns the value of the INVENTORY\_SESSION key.<br/><br/>**Parameters:** - <br/><br/>**Return:** Int |
| **Region** | Returns the currently used regulatory region.<br/><br/>**Parameters:** - <br/><br/>**Return:** Enums.Regulatory\_Region |
| **Tag-Population** | Returns the value of the INVENTORY\_TAG\_POPULATION key.<br/><br/>**Parameters:** - <br/><br/>**Return:** Int |
| **SearchMode** | Returns the value of the INVENTORY\_SEARCH\_MODE key.<br/><br/>**Parameters:** - <br/><br/>**Return:** Int |
| **keyInfo** | Returns the KeyInfo of the specified key.<br/><br/>**Parameters:**<br/>- Ipj\_Key – to get from the reader<br/><br/>**Return:** Enums.KeyInfo |

**Class name: de.acdgruppe.m2uhf\_library.Get**
| **Name** | **Description** |
| --- | --- |
| **keyValue** | Returns the value of the specified key with bank index 0 and value index 0. Not all keys can be queried. To get Region or RF mode values use the functions Region or RFMode. Check with get.keyInfo if the key is readable.<br/><br/>**Parameters:**<br/>- Ipj\_Key – to get from the reader<br/><br/>**Return:** Int – value of the key. -1 is returned if the key can't be read, if it is not allowed to read -2 is returned |
| **key** | Returns the value of the specified key with the specified bank index and value index. Not all keys can be queried. To get Region or RF mode values use the functions Region or RFMode. Check with get.keyInfo if the key is readable. The ipj\_get function is used to get keys ([ApiGuide/ApiFunctions.html#ipj-get](https://platform.impinj.com/indy/itk/latest/ApiGuide/ApiFunctions.html#ipj-get)).<br/><br/>**Parameters:**<br/>- Ipj\_Key – to get from the reader<br/>- Int – bank index of the key to get<br/>- Int – value index of the key to get<br/><br/>**Return:** Int – value of the key. -1 is returned if the key can't be read, if it is not allowed to read -2 is returned |

#### Set settings

Some settings are region specific. So they might be not available in every region. The region itself can only be changed on modules with ETSI certification.

**Limitations:**

- Changing the region on modules with FCC certification is not allowed.
- TX power range is limited due to certifications:
  - Shortrange modules: 10 dBm to 23 dBm
  - Midrange modules ETSI: 10 dBm to 27 dBm
  - Midrange modules FCC with FCC region: 10 dBm to 26,5 dBm
  - Midrange modules FCC with other regions: 10 dBm to 27 dBm

The Set class provides the following functions:

**Class name: de.acdgruppe.m2uhf\_library.Set**
| **Name** | **Description** |
| --- | --- |
| **TxPower** | Sets the value of the ANTENNA\_TX\_POWER key in dBm. See above for limitations<br/><br/>**Parameters:**<br/>- Float – dBmvalue<br/><br/>**Return:** Ipj\_Error |
| **RFMode** | Sets the value of the RF\_MODE key<br/><br/>**Parameters:**<br/>- Int – rfmode<br/><br/>**Return:** Ipj\_Error |
| **Session** | Sets the value of the INVENTORY\_SESSION key<br/><br/>**Parameters:**<br/>- Int – sessionnumber<br/><br/>**Return:** Ipj\_Error |

**Class name: de.acdgruppe.m2uhf\_library.Set**
| **Name** | **Description** |
| --- | --- |
| **Tag-Population** | Sets the value of the INVENTORY\_TAG\_POPULATION key<br/><br/>**Parameters:**<br/>- Int – tagpopulationestimatenumber<br/><br/>**Return:** Ipj\_Error |
| **SearchMode** | Sets the value of the INVENTORY\_SEARCH\_MODE key<br/><br/>**Parameters:**<br/>- Int – searchmode<br/><br/>**Return:** Ipj\_Error |
| **EtsiRegion** | Sets the current ETSI region. With this function the Regulatory\_Region can be switched from ETSI\_EN\_302\_208 to INDIA\_865\_867\_MHZ and vice versa. Only allowed for modules with ETSI DeviceCertification<br/><br/>**Parameters:**<br/>- Regulatory\_Region – to set to the reader<br/><br/>**Return:** Ipj\_Error |
| **keyValue** | Sets the value of the specified key with bank index 0 and value index 0. Not all keys can be set. To set Region or RF mode values use the functions EtsiRegion or RFMode. Check with get.keyInfo if the key is writeable.<br/><br/>**Parameters:**<br/>- Ipj\_Key – to set to the reader<br/>- Int – value to set<br/><br/>**Return:** Ipj\_Error |
| **key** | Sets the value of the specified key with the specified bank index and value index. Not all keys can be set. To set Region or RF mode values use the functions EtsiRegion or RFMode. Check with get.keyInfo if the key is writeable. The ipj\_set function is used to set keys ([ApiGuide/ApiFunctions.html#ipj-set](https://platform.impinj.com/indy/itk/latest/ApiGuide/ApiFunctions.html#ipj-set)).<br/><br/>**Parameters:**<br/>- Ipj\_Key – to set to the reader<br/>- Int – bank index of the key to set<br/>- Int – value index of the key to set<br/>- Int – value to set<br/><br/>**Return:** Int |

### Enums

The M2UHF-RFID API has ported some enums from the IRI API. Not needed or unnecessary enums are currently not ported in java. All error codes (Ipj\_Error) and key codes (Ipj\_Key) are in separate classes. All other enums are in the Enums class of the API.

#### Ipj error enum

All ipj\_error codes from the IRI API are ported to Java. They were renamed to shorten the name:

Instead of E\_IPJ\_ERROR\_SET\_KEY\_INVALID the enum is called SET\_KEY\_INVALID.

Each enum has the same value as defined in the IRI API.

All error codes are listed in the IRI API documentation (ApiGuide/ErrorCodes.html) and [online](https://platform.impinj.com/indy/itk/latest/ApiGuide/ErrorCodes.html).

The following enums are added by ACD to handle more errors:

**Enum name: de.acdgruppe.m2uhf\_library.Ipj\_Error**
| **Name** | **Description** | **Value (Long)** |
| --- | --- | --|
| **UNKNOWN\_ERROR\_CODE** | Is returned when an invalid long value is converted to an Ipj\_Error enum | 0x1D |
| **KEY\_SET\_NOT\_ALLOWED** | When the user wants to set or get a key which is not allowed by ACD policy (e.g. region key) | 0x1E |
| **MODULE\_NOT\_PLUGGED** | Is returned when the module is not plugged | 0x100 |
| **MODULE\_NOT\_POWERED** | Is returned when the module is not powered | 0x101 |
| **MODULE\_CONNECTION\_ERROR** | Is returned when the module is not connected properly because the connection to the ACD ModuleService failed | 0x102 |
| **MODULE\_PERMISSION\_ERROR** | Is returned when the App using the M2UHF-RFID API doesn't have [WRITE\_EXTERNAL\_STORAGE](https://developer.android.com/reference/android/Manifest.permission#WRITE_EXTERNAL_STORAGE) and [READ\_EXTERNAL\_STORAGE](https://developer.android.com/reference/android/Manifest.permission#READ_EXTERNAL_STORAGE) permissions | 0x103 |
| **API\_COMMAND\_STILL\_RUNNING** | Currently unused | 0x200000D |

#### Ipj key enum

All ipj\_key codes from the IRI API are ported to Java. They were renamed to shorten the name:

Instead of E\_IPJ\_KEY\_BOOTSTRAP\_VERSION the enum is called BOOTSTRAP\_VERSION.

Each enum has the same value as defined in the IRI API.

All key codes and more context are listed in the IRI API documentation (ApiGuide/KeyCodes.html) and [online](https://platform.impinj.com/indy/itk/latest/ApiGuide/KeyCodes.html).

The following enums are added by ACD:

**Enum name: de.acdgruppe.m2uhf\_library.Ipj\_Key**
| **Name** | **Description** | **Value (Long)** |
| --- | --- | --- |
| **UNKNOWN\_KEY** | Is returned when an invalid long value is converted to a Ipj\_Key enum | 0x1C |

#### Other enums

There are more enums and structs ported to java, they are collected in the Enums class. More information about some of the enums can be found in the IRI API documentation (ApiGuide/Structures.html, ApiGuide/Defines.html) and [online](https://platform.impinj.com/indy/itk/latest/ApiGuide/Structures.html) ([defines](https://platform.impinj.com/indy/itk/latest/ApiGuide/Defines.html)).

**Class name: de.acdgruppe.m2uhf\_library.Enums**
| **Name** | **Description** |
| --- | --- |
| **CHANNEL\_TABLE** | List with all supported channels for each Regulatory\_Region. The order of the regions is the same as Regulatory\_Region. So use the CHANNEL\_TABLE.get(index) function with Regulatory\_Region.ordinal() as index to get the channels from a region |
| **DeviceType** | There are currently two versions of M2UHF-RFID module:<br/>- SR: M2UHF-RFID Shortrange module, with Impinj RS500<br/>- MR: M2UHF-RFID Midrange module, with Impinj RS1000|
| **DeviceCertification** | There are two certification variants of each device type:<br/>- GX module: For all regions with FCC standard<br/>- EU module: For all regions with ETSI standard<br/>A module can only be used in FCC **or** ETSI regions |
| **Regulatory\_Region** | Contains all available regulatory regions. Please use the IRI API documentation to learn more about regions ([ApiGuide/Defines.html#ipj-region-enum](https://platform.impinj.com/indy/itk/latest/ApiGuide/Defines.html#ipj-region-enum)) |
| **KeyType** | Defines a primitive type for a Ipj\_Key |
| **KeyPermission** | Defines a permission state for a Ipj\_Key |
| **KeyInfo** | This class holds a complete ipj\_key\_info struct. For each property exists a boolean property. It is set to true if the property is set. Otherwise, the property is null or is set to the default value<br/><br/>**Properties:**<br/>- KeyType of the specified key<br/>- Int – count (number of banks)<br/>- Int – length (number of values)<br/>- KeyPermission of the specified key |
| **MemBank** | Contains enums for each memory bank of a tag |
| **TagOperationType** | Contains enums for each possible reader action. IRI API: ([ApiGuide/Defines.html](https://platform.impinj.com/indy/itk/latest/ApiGuide/Defines.html#project0iri_8h_1ae961d8c23fabe3f403ae7f1b36da4e0e)) |

**Class name: de.acdgruppe.m2uhf\_library.Enums**
| **Name** | **Description** |
| --- | --- |
| **IpjTag** | This class holds a complete ipj\_tag struct. For each property exists a boolean property. It is set to true if the property is set. Otherwise, the property is null or is set to the default value<br/><br/>**Properties:**<br/>- Short[] – each array element contains a byte of the EPC memory bank<br/>- Short[] – each array element contains a byte of the TID memory bank<br/>- Long – the pcof the tag<br/>- Long – the xpcof the tag<br/>- Long – the crcof the tag<br/>- Long – the timestamp of the tag<br/>- Int – the rssiof the tag<br/>- Int – the phaseof the tag<br/>- Long – the channel of the tag |
| **IpjTagOperation-Report** | This class holds a complete ipj\_tag\_operation\_report struct from the reader. For each property exists a boolean property. It is set to true if the property is set. Otherwise, the property is null or is set to the default value<br/><br/>**Properties:**<br/>- Ipj\_Error – is set when there was an error while performing the last action<br/>- IpjTag – contains the tag enum that the report is about<br/>- TagOperationType – the operation type of this report<br/>- Short[] – tag operation data (e.g. the data of the Reserved memory from a read action). Each array element contains 1 byte of data<br/>- Long – the number of retries<br/>- Long – the timestamp of the report |
| **LockMode** | Defines a lock mode of a tag |

### Code example

The two included documents show the usage of the API. They are written in Java, but they won't compile. It is a collection of functions to get started. The _Module\_Handling.java_ file shows how to handle the module functions in an Android activity. The _Reader\_Start.java_ file shows how to initialize and use the reader.

## Using the M2UHF-RFID API

### Preparation

Before the API can be used a few things have to be prepared:

- Make sure ACD ModuleService with version 2.1 or higher is installed (shipped with ACD Android Industrial+ 1.8 or newer). Check the Android Build Number in the ACD SystemApp, it should contain "v1.8"
- The app using this API needs [WRITE\_EXTERNAL\_STORAGE](https://developer.android.com/reference/android/Manifest.permission#WRITE_EXTERNAL_STORAGE) and [READ\_EXTERNAL\_STORAGE](https://developer.android.com/reference/android/Manifest.permission#READ_EXTERNAL_STORAGE) permissions granted before using the API
- The API is partially written in Kotlin, this means the app using this API needs to provide the Kotlin plugin. For apps build with gradle, add the following lines:
  - apply plugin: 'kotlin-android'(to line 2 of the app _build.gradle_ file)
  - classpath "org.jetbrains.kotlin:kotlin-gradle-plugin:1.7.10"

(to the dependency tag of the project _build.gradle_ file)

### Add the API to the app

The M2UHF-RFID API must be added to the app as an additional module.

1. In the project settings, go to Module's settings and click on "Create new Module ('+' Button)". Then use the option "Import .JAR or .AAR package" and select the .aar file. Change the subproject name (e.g. m2uhf\_api), do not use hyphens. Execute a gradle sync. The new module should now be visible in the project tool window. If not, change the first line of _settings.gradle_ file to<br/>include ':app', ':m2uhf\_api'<br/>and do a gradle sync.

2. Go to the dependency settings, select the app module and add the M2UHF-RFID API module (created in the previous step) as a new module dependency to the app (select implementation configuration). If there is no Option in the menu, it has to be done manually:<br/>Add implementation project(path: ':m2uhf\_api') to the dependency tag of the app _build.gradle_ file.

3. Rebuild the project. After that the M2UHF-RFID API can be used in the app.

### Add JavaDoc to the app

With the M2UHF-RFID API there are also JavaDoc files which can be added in Android Studio to use JavaDoc while developing:

1. Extract the JavaDoc Zip file and copy all files to the module directory of the M2UHF-RFID API in a new folder (e.g. _javaDocFiles_)
2. Define the JavaDoc for the M2UHF-RFID API:<br/>- Open the file _.idea/libraries/Gradle\_artifacts\_m2uhf\_.....xml_ (named like the module name of the API)<br/>- Add the path of the folder where the JavDoc files were copied to:<br/>\<JAVADOC\><br/><br/>\<root url="file://\$PROJECT\_DIR\$/m2uhf\_api/javaDocFiles" /\><br/><br/>\</JAVADOC\>
3. Sync and rebuild the project

### Troubleshooting

Some things that can be checked if there are errors:

- Ensure that all function are called in the correct order (plugged -\> powered -\> init -\> start)
- If the module is not recongnized (onModulePlugged is not called):

If there is no toast or notification when the module is plugged or unplugged, then the module was not recognized by the ACD ModuleService. Only replugging the module helps in this case. Sometimes the contact pins of the module are shifted. Try to push the module a little upwards (from the back towards the display) when attaching it.

- When the onModulePlugged event is triggered, but the module can't be powered on:

Check if the ACD ModuleService Plugin was copied to sdcard/ACD/Add-On-Modules. Only one amsp file (named m2uhf-background…) and one folder (named oat) should exist in this directory.

Try to delete all files in the folder and do a restart of the device. After starting the app (when a connection to the ACD ModuleService is established) these files should be created again.

- Make sure to not to send too many API commands at once. This can trigger API\_CONNECTION\_READ\_TIMEOUT or API\_CONNECTION\_WRITE\_TIMEOUT errors
- Check versions: M2Smart®SE should use Image v1.8 or newer, the MCon should use version v1.20 or newer
- If there are API\_CONNECTION\_READ\_TIMEOUT errorswhen the reader is initialized, make sure to wait 1000 ms before initializing the reader after it is powered on

## Version history

**Version 1.18**

- Add support for tags with longer than 16 words EPC IDs (new limit is 32 words)
- In older versions of this documentation the maximum length of the selected tag ID was specified as 32 words which was wrong. With the above mentioned change the specification in the documentation is now correct again.

**Version 1.17**

- Add TX power limitations due to certificatiions
- Fix select tag bug where reader will stop working if the selected tag has more than 16 words
- Disable E\_IPJ\_WRITE\_EPC\_LENGTH\_CONTROL\_AUTO when writing to EPC memory to prevent unintended EPC length changes
- Update Java to V15, SDK to V32, Kotlin to V1.7.10 and Gradle to V7.2.2
- Change data type to float of TXPower function in Get and Set class

**Version 1.14**

- Bugfixes for module handling
- Write function can now write to the first 2 words of EPC memory bank

**Version 1.11**

- Bugfixes

**Version 1.10**

- Add new function to switch ETSI regions (ETSI\_EN \<-\> India)

**Version 1.09**

- Region ID is read only (it is not allowed to change the region)
- Compatibility upgrade for ModuleService 2.1:

Version 1.09 and newer of the API is only compatible to ModuleService 2.1

(M2Smart®SE Image1.8) or newer

Version 1.08 and older of the API is only compatible to ModuleService 1.7 (M2Smart®SE Image 1.7)

- Improved ModuleService plugin handling
- Renamed Enums.Regulatory\_Region#ETSI\_EN\_302\_208

**Version 1.08**

- First official release
